from Tkinter import *
from time import gmtime, strftime
import tkMessageBox
import requests
import json
import sys
from openpyxl import Workbook
from tkFileDialog import askopenfilename
from openpyxl import load_workbook
 
window = Tk()

filename = None

window.title("Welcome to Perfecto User Management") 
window.geometry('800x500')


lbl = Label(window, text="Cloud")
lbl.grid(column=0, row=2)

lbl = Label(window, text="UserName")
lbl.grid(column=0, row=3)

lbl = Label(window, text="Password")
lbl.grid(column=0, row=4)

lbl = Label(window, text="Roles")
lbl.grid(column=0, row=6)

lbl = Label(window, text="(Comma Seperated Values, Case Sensitive)")
lbl.grid(column=2, row=6)
 

cloud = StringVar() #Password variable
cloudentry = Entry(window, textvariable=cloud)
cloudentry.grid(column=1, row=2)

username = StringVar() #Password variable
usernameentry = Entry(window, textvariable=username,  state='disabled')
usernameentry.grid(column=1, row=3)

password = StringVar() #Password variable
passEntry = Entry(window, textvariable=password, show='*',  state='disabled')
passEntry.grid(column=1, row=4)

selected = IntVar()



singleuser = StringVar() 
singleuserentry = Entry(window, textvariable=singleuser)
singleuserentry.grid(column=1, row=7)

ExcelFile = StringVar() 
ExcelFilerentry = Entry(window, textvariable=ExcelFile)
ExcelFilerentry.grid(column=1, row=8)

stoken = StringVar() 
stokenentry = Entry(window, textvariable=stoken)
stokenentry.grid(column=1, row=5)

roles = StringVar() 
rolesentry = Entry(window, textvariable=roles)
rolesentry.grid(column=1, row=6)




def disableradiobuttons():
    if(selected.get() == 1):
        ExcelFilerentry.configure(state="disabled")
        singleuserentry.configure(state="normal")
        rolesentry.configure(state="normal")
    if(selected.get() == 2):
        singleuserentry.configure(state="disabled")
        ExcelFilerentry.configure(state="normal")
        rolesentry.configure(state="normal")
    if(selected.get() == 3):
        singleuserentry.configure(state="disabled")
        ExcelFilerentry.configure(state="disabled")
        rolesentry.configure(state="disabled")
    if(chk_state.get() == True):
        usernameentry.configure(state="disabled")
        passEntry.configure(state="disabled")
        stokenentry.configure(state="normal")
    if(chk_state.get() == False):
        usernameentry.configure(state="normal")
        passEntry.configure(state="normal")
        stokenentry.configure(state="disabled")

    
def clicked():
    #res = "Welcome to " + txt.get()
    #lbl.configure(text= res)
    if (password.get() == ""):
        tkMessageBox.showinfo('Message title', "Please Enter Password Field")
    print selected.get()
    tkMessageBox.showinfo('Message title', selected.get())


def deleteprocess():
    if(checkinputs1() and checkinputs2()):
        if(selected.get() == 1):
            deleteconfirmation("Single", "Delete")
        if(selected.get() == 2):
            deleteconfirmation("Muluser", "Delete")
        if(selected.get() == 3):
            deleteconfirmation("Alluser", "Delete")


def addrolesprocess():
    if(checkinputs1() and checkinputs2()):
        if(selected.get() == 1):
            rolesoperationconfirmation("Single", "Add")
        if(selected.get() == 2):
            rolesoperationconfirmation("Muluser", "Add")
        if(selected.get() == 3):
            rolesoperationconfirmation("Alluser", "Add")


def deleterolesprocess():
    if(checkinputs1() and checkinputs2()):
        if(selected.get() == 1):
            rolesoperationconfirmation("Single", "Delete")
        if(selected.get() == 2):
            rolesoperationconfirmation("Muluser", "Delete")
        if(selected.get() == 3):
            rolesoperationconfirmation("Alluser", "Delete")


def rolesoperationconfirmation(usermode, oper):
    result = tkMessageBox.askquestion("Delete", "Are You Sure?", icon='warning')
    if result == 'yes':
        if (usermode == "Single"):
            print "Role Operation for Single User"
            singleuserroles(oper)
        elif (usermode == "Alluser"):
            print "Role Operation for All User"
            roleoperationall(usermode, oper)
        elif (usermode == "Muluser"):
            print "Role Operation for Multi User"
            roleoperationall(usermode, oper)
    else:
        print "Role Operation Canceled by User"                  
            
def deleteconfirmation(usermode, oper):
    result = tkMessageBox.askquestion("Delete", "Are You Sure?", icon='warning')
    if result == 'yes':
        if (usermode == "Single"):
            print "Deleting Given user in cloud"
            deleteone()
        elif (usermode == "Alluser"):
            print "Deleting the all users in cloud"
            deleteall(usermode, oper)
        elif (usermode == "Muluser"):
            print "Deleting the all users in cloud"
            deleteall(usermode, oper)
    else:
        print "Delete Canceled by User"            


def roleoperationall(usermode, oper):
    #Getting list of user in given cloud

    print oper
    print usermode
    save_stdout = sys.stdout
    fh = open("log.txt", "a+")
    sys.stdout = fh



    if (usermode == "Alluser"):
        if(checkrolesinput()):
            uri = "/services/users?operation=list"
            r = postrequest(uri)
            print r.status_code

            uroles = roles.get()
            uroles = uroles.replace(" ","")

            if(r.status_code == 200):
                content = json.loads(r.content)
                print "Number of users in the cloud %s" %len(content['users'])
                for each in range(0, len(content['users'])):
                    if (content['users'][each]["status"] == "ACTIVE"):
                        if (oper == "Add"):
                            #Add roles to active user
                            uri = "/services/users/"+content['users'][each]["username"]+"?operation=addRoles&roles="+uroles
                            r = postrequest(uri)
                            if(r.status_code == 200):
                                print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + content['users'][each]["username"]  + "  -  Roles Added"
                                fh.flush()
                        if (oper == "Delete"):
                            #Delete roles to active user
                            uri = "/services/users/"+content['users'][each]["username"]+"?operation=removeRoles&roles="+uroles
                            r = postrequest(uri)
                            if(r.status_code == 200):
                                print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + content['users'][each]["username"]  + "  -  Roles Deleted"
                                fh.flush()
                        #if (each == 20):
                        #    break
                tkMessageBox.showinfo('Message title', oper+" Role Operation Finished")

            else:
                print "printing error"
                fh.close()
                sys.stdout = save_stdout
                tkMessageBox.showinfo('Message title', r.content)
    elif (usermode == 'Muluser'):
        print "hi"+str(filename)

        if(checkfilesinput()):
            global filename
            filename = ExcelFile.get()
            wb = load_workbook(filename = str(filename))
            sheet_ranges = wb['ActiveUser']

            for each in range(2, 4000):
                if sheet_ranges["A"+str(each)].value == None:
                    print "breaking"
                    break 
                uname = sheet_ranges["A"+str(each)].value
                uroles = sheet_ranges["B"+str(each)].value
                uroles = uroles.replace(" ","")
                if (oper == "Add"):
                    uri = "/services/users/"+uname+"?operation=addRoles&roles="+uroles
                    r = postrequest(uri)
                    if(r.status_code == 200):
                        print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + uname  + "  -  Roles Added"
                        fh.flush()
                    else:
                        print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + uname  + "  -  Roles Not Added" + r.content
                        fh.flush()                   
                if (oper == "Delete"):
                    uri = "/services/users/"+uname+"?operation=removeRoles&roles="+uroles
                    r = postrequest(uri)
                    if(r.status_code == 200):
                        print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + uname  + "  -  Roles Deleted"
                        fh.flush()
                    else:
                        print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + uname  + "  -  Roles Not Deleted" + r.content
                        fh.flush()      
                #if (each == 20):
                #    break

            tkMessageBox.showinfo('Message title', oper+" Role Operation Finished")
    fh.close()
    sys.stdout = save_stdout

def deleteall(usermode, oper):
    #Getting list of user in given cloud
    save_stdout = sys.stdout
    fh = open("log.txt", "a+")
    sys.stdout = fh

    if (usermode == "Alluser"):
        uri = "/services/users?operation=list"
        r = postrequest(uri)
        if(r.status_code == 200):
            content = json.loads(r.content)
            print "Number of users in the cloud %s" %len(content['users'])
            for each in range(0, len(content['users'])):
                if (content['users'][each]["status"] == "ACTIVE"):
                    if(content['users'][each]["status"] != username.get()):
                        #If user is active delete it
                        uri = "/services/users/"+content['users'][each]["username"]+"?operation=delete"
                        r = postrequest(uri)
                        if(r.status_code == 200):
                            print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + content['users'][each]["username"]  + "  -  DELETED"
                            fh.flush()
                    #if (each == 20):
                    #    break
            tkMessageBox.showinfo('Message title', "Delete Finished")
        else:
            print "printing error"
            fh.close()
            sys.stdout = save_stdout
            tkMessageBox.showinfo('Message title', r.content)
    elif (usermode == 'Muluser'):
        if(checkfilesinput()):
            global filename
            filename = ExcelFile.get()
            wb = load_workbook(filename = str(filename))
            sheet_ranges = wb['ActiveUser']

            for each in range(2, 4000):
                if sheet_ranges["A"+str(each)].value == None:
                    print "breaking"
                    break 
                uname = sheet_ranges["A"+str(each)].value

                #Not Implemented yet
                if (oper == "Add"):
                    print "Adding given User"
                    #Yet to Impleemnt              
                if (oper == "Delete"):
                    print "Deleting given User"
                    uri = "/services/users/"+uname+"?operation=delete"
                    r = postrequest(uri)
                    if(r.status_code == 200):
                        print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + uname  + "  -  User Deleted"
                        fh.flush()
                    else:
                        print strftime("%Y-%m-%d %H:%M:%S", gmtime()) + "-" + uname  + "  -  User Not Deleted" + r.content
                        fh.flush()      
                #if (each == 20):
                #    break

            tkMessageBox.showinfo('Message title', oper+" Role Operation Finished")
    fh.close()
    sys.stdout = save_stdout


def RetrieveActiveUser():
    #Getting list of user in given cloud

    if(selected.get() == 1):
        ExcelFilerentry.configure(state="disabled")
        ExcelFilerentry.update()

    if(checkinputs1()):

        wb = Workbook()

        dest_filename = 'CloudRetrievedUser.xlsx'

        ws1 = wb.active
        ws1.title = "ActiveUser"

        ws1.cell(column=1, row=1, value="ACTIVE_USER")
        ws1.cell(column=2, row=1, value="ENROLLED_ROLES")

        
        rowcount = 2
        save_stdout = sys.stdout
        fh = open("log.txt", "a+")
        sys.stdout = fh
        uri = "/services/users?operation=list"
        r = postrequest(uri)
        if(r.status_code == 200):
            content = json.loads(r.content)
            print "Number of users in the cloud %s" %len(content['users'])
            for each in range(0, len(content['users'])):
                if (content['users'][each]["status"] == "ACTIVE"):
                    #If user is active delete it
                    uri = "/services/users/"+content['users'][each]["username"]+"?operation=info"
                    ws1.cell(column=1, row=rowcount, value=content['users'][each]["username"])
                    roles = str(content['users'][each]["roles"])
                    roles = roles.replace("[","")               
                    roles = roles.replace("]","")
                    roles = roles.replace("u'","")
                    roles = roles.replace("'","")
                    ws1.cell(column=2, row=rowcount, value=roles)
                    rowcount += 1
                    #if (each == 20):
                    #    break
            tkMessageBox.showinfo('Message title', "All Active user in the cloud Retrived in "+dest_filename)
            wb.save(filename = dest_filename)
        else:
            print "printing error"
            fh.close()
            sys.stdout = save_stdout
            tkMessageBox.showinfo('Message title', r.content)
        fh.close()
        sys.stdout = save_stdout
    
def singleuserroles(oper):  
    if(checkrolesinput()):
        uroles = roles.get()
        uroles = uroles.replace(" ","")
        if (oper == "Add"):
           print "Adding Roles to given User"
           print chk_state.get()
           uri = "/services/users/"+singleuser.get()+"?operation=addRoles&roles="+uroles
           r = postrequest(uri)
        if (oper == "Delete"):
           print "Deleting Roles to given User"
           uri = "/services/users/"+singleuser.get()+"?operation=removeRoles&roles="+uroles
           r = postrequest(uri)
        if(r.status_code == 200):
            if (oper == "Add"):
                tkMessageBox.showinfo('Message title', "Roles Added")
            elif (oper == "Delete"):
                tkMessageBox.showinfo('Message title', "Roles Deleted")
        else:
            print "printing error"
            tkMessageBox.showinfo('Message title', r.content)    


    
def deleteone():  
    if(checkinputs1()):
        print "Deleting User"
        uri = "/services/users/"+singleuser.get()+"?operation=delete"
        if(singleuser.get() != username.get()):
            r = postrequest(uri)
            if(r.status_code == 200):
                tkMessageBox.showinfo('Message title', "Deleted")
            else:
                print "printing error"
                tkMessageBox.showinfo('Message title', r.content)
        else:
            tkMessageBox.showinfo('Message title', "Same User Can't be deleted") 
    
def postrequest(url):
        host = cloud.get()
        host = host.replace("https://","")
        host = host.replace("http://","")
        url = "https://"+host+url
        #If SSO enabled cloud append required parameters
        if(chk_state.get()):
            url = url+"&SecurityToken="+stoken.get()
        else:
            url = url+"&user="+username.get()+"&password="+password.get()
        #print url
        r = requests.post(url)
        return r

def checkinputs1():
    if (cloud.get() == ""):
        tkMessageBox.showinfo('Message title', "Please Enter Cloud Field")
        return False
    if (chk_state.get() == False and username.get() == ""):
        tkMessageBox.showinfo('Message title', "Please Enter UserName Field")
        return False
    if (chk_state.get() == False and password.get() == ""):
        tkMessageBox.showinfo('Message title', "Please Enter Password Field")
        return False
    if (chk_state.get() == True and stoken.get() == ""):
        tkMessageBox.showinfo('Message title', "Please provide SecurityToken")
        return False
    return True

def checkinputs2():
    if(selected.get() == 0):
        tkMessageBox.showinfo('Message title', "Please Select One User, Multiple User or All User Radio button")
        return False
    if(selected.get() == 1 and singleuser.get() == ""):
        tkMessageBox.showinfo('Message title', "Please Enter Single User Email Id to delete")
        return False
    return True

def checkrolesinput():
     if (roles.get() == ""):
        tkMessageBox.showinfo('Message title', "Please Enter Roles to Add/Delete")
        return False
     return True   

def checkfilesinput():
     if (ExcelFile.get() == ""):
        tkMessageBox.showinfo('Message title', "Please Provide Input File")
        return False
     return True   

def open_file_handler():
    global filename
    print filename
    filename = askopenfilename()
    ExcelFilerentry.delete(0,END)
    ExcelFilerentry.insert(0,filename)
    print file
    return file  
        
#btn = Button(window, text="Click Me", command=clicked)
#btn.grid(column=5, row=2)       

btn = Button(window, text="DeleteUser", command=deleteprocess, bg="red", fg="black", height=3)
btn.grid(column=3, row=11)          
btn = Button(window, text="AddRoles", command=addrolesprocess)
btn.grid(column=1, row=11)
btn = Button(window, text="DeleteRoles", command=deleterolesprocess)
btn.grid(column=2, row=11) 
btn = Button(window, text="RetrieveActiveUser",  command=RetrieveActiveUser)
btn.grid(column=0, row=11) 

lbl = Label(window, text="(Careful)")
lbl.grid(column=3, row=12)

rad1 = Radiobutton(window,text='SingleUser', value=1, variable=selected, height=3, command=disableradiobuttons) 
rad2 = Radiobutton(window,text='FromExcel', value=2, variable=selected, command=disableradiobuttons) 
rad3 = Radiobutton(window,text='All Active User(Careful)', value=3, variable=selected, command=disableradiobuttons)

rad1.grid(column=0, row=7)
rad2.grid(column=0, row=8)
rad3.grid(column=0, row=9)


open_file = Button(window, command=open_file_handler, text="OPEN FILE")
open_file.grid(column=2, row=8) 

chk_state = BooleanVar()
chk_state.set(True)
chk = Checkbutton(window, text='SecurityToken', var=chk_state, command=disableradiobuttons)
chk.grid(column=0, row=5)

    
window.mainloop()